(function() {
    IntelliServe_Dxtreme.ClientContactViewModel = function(data) {
            this.Oid = ko.observable();
            this.Client1 = ko.observable();
            this.FirstName = ko.observable();
            this.LastName = ko.observable();
            this.Email = ko.observable();
            this.CellNo = ko.observable();
            this.Phone = ko.observable();
            this.ContactType = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.ClientContactViewModel.prototype, {
        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.Client1)
                    this.Client1(new IntelliServe_Dxtreme.ClientViewModel(data.Client1));
                this.FirstName(data.FirstName);
                this.LastName(data.LastName);
                this.Email(data.Email);
                this.CellNo(data.CellNo);
                this.Phone(data.Phone);
                this.ContactType(data.ContactType);
                this.GCRecord(data.GCRecord);
            }
        },

        toJS: function () {
            return {
                Oid: this.Oid(),
                Client1: this.Client1(),
                FirstName: this.FirstName(),
                LastName: this.LastName(),
                Email: this.Email(),
                CellNo: this.CellNo(),
                Phone: this.Phone(),
            };
        },

        clear: function() {
            this.Oid(undefined);
            this.Client1(undefined);
            this.FirstName(undefined);
            this.LastName(undefined);
            this.Email(undefined);
            this.CellNo(undefined);
            this.Phone(undefined);
            this.ContactType(undefined);
            this.GCRecord(undefined);
        }
    });
})();