(function() {
    IntelliServe_Dxtreme.ConsignmentViewModel = function(data) {
            this.Oid = ko.observable();
            this.Client1 = ko.observable();
            this.Invoice1 = ko.observable();
            this.Location = ko.observable();
            this.Location1 = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.ConsignmentViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Client1: IntelliServe_Dxtreme.db.objectLink("Clients", this.Client1() ? this.Client1().Oid(): undefined),
                Invoice1: IntelliServe_Dxtreme.db.objectLink("Invoices", this.Invoice1() ? this.Invoice1().Oid(): undefined),
                Location: IntelliServe_Dxtreme.db.objectLink("Locations", this.Location() ? this.Location().Oid(): undefined),
                Location1: IntelliServe_Dxtreme.db.objectLink("Locations", this.Location1() ? this.Location1().Oid(): undefined),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.Client1)
                    this.Client1(new IntelliServe_Dxtreme.ClientViewModel(data.Client1));
                if(data.Invoice1)
                    this.Invoice1(new IntelliServe_Dxtreme.InvoiceViewModel(data.Invoice1));
                if(data.Location)
                    this.Location(new IntelliServe_Dxtreme.LocationViewModel(data.Location));
                if(data.Location1)
                    this.Location1(new IntelliServe_Dxtreme.LocationViewModel(data.Location1));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Client1(undefined);
            this.Invoice1(undefined);
            this.Location(undefined);
            this.Location1(undefined);
        }
    });
})();