(function() {
    IntelliServe_Dxtreme.CountryViewModel = function(data) {
            this.Oid = ko.observable();
            this.Name = ko.observable();
            this.PhoneCode = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            this.CountryCode = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.CountryViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Name: this.Name(),
                PhoneCode: this.PhoneCode(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
                CountryCode: this.CountryCode(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Name(data.Name);
                this.PhoneCode(data.PhoneCode);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
                this.CountryCode(data.CountryCode);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Name(undefined);
            this.PhoneCode(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
            this.CountryCode(undefined);
        }
    });
})();