(function() {
    IntelliServe_Dxtreme.CustomStatuViewModel = function(data) {
            this.Oid = ko.observable();
            this.Color = ko.observable();
            this.Status = ko.observable();
            this.IsCompleted = ko.observable();
            this.IsDefault = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.CustomStatuViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Color: this.Color(),
                Status: this.Status(),
                StatusDescription: this.StatusDescription(),
                IsCompleted: this.IsCompleted(),
                IsDefault: this.IsDefault(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Color(data.Color);
                this.Status(data.Status);
                this.IsCompleted(data.IsCompleted);
                this.IsDefault(data.IsDefault);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Color(undefined);
            this.Status(undefined);
            this.IsCompleted(undefined);
            this.IsDefault(undefined);
            this.GCRecord(undefined);
        }
    });
})();