﻿(function () {
    IntelliServe_Dxtreme.EquipmentViewModel = function (data) {
        this.Oid = ko.observable();
        this.Client1 = ko.observable();
        this.Location1 = ko.observable();
        this.SerialNumber = ko.observable();
        this.Make1 = ko.observable();
        this.Model1 = ko.observable();
        this.EquipmentType1 = ko.observable();
        this.Warranty = ko.observable();
        this.DateManufactured = ko.observable();
        this.Image = ko.observable();
        this.DatePurchased = ko.observable();
        this.Accessories = ko.observable();
        this.RunningHoursPerDay = ko.observable();
        this.HoursBetweenServices = ko.observable();
        this.RunningDaysPerWeek = ko.observable();
        this.LastServiceDate = ko.observable();
        this.GCRecord = ko.observable();
        if (data)
            this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.EquipmentViewModel.prototype, {
        toJS: function () {
            return {
                Oid: this.Oid(),
                SerialNumber: this.SerialNumber(),
                EquipmentType1: this.EquipmentType1(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function (data) {
            if (data) {
                this.Oid(data.Oid);
                this.SerialNumber(data.SerialNumber);
                if (data.EquipmentType1)
                    this.EquipmentType1(new IntelliServe_Dxtreme.EquipmentTypeViewModel(data.EquipmentType1));
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function () {
            this.Oid(undefined);
            this.SerialNumber(undefined);
            this.GCRecord(undefined);
        }
    });
})();