(function() {
    IntelliServe_Dxtreme.EventEntryBasViewModel = function(data) {
            this.Oid = ko.observable();
            this.CalendarEventBase1 = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.EventEntryBasViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                CalendarEventBase1: IntelliServe_Dxtreme.db.objectLink("CalendarEventBases", this.CalendarEventBase1() ? this.CalendarEventBase1().Oid(): undefined),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.CalendarEventBase1)
                    this.CalendarEventBase1(new IntelliServe_Dxtreme.CalendarEventBasViewModel(data.CalendarEventBase1));
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.CalendarEventBase1(undefined);
            this.GCRecord(undefined);
        }
    });
})();