﻿(function () {
    IntelliServe_Dxtreme.FaultTypeViewModel = function (data) {
        this.Oid = ko.observable();
        this.Fault = ko.observable();
        this.GCRecord = ko.observable();
        if (data)
            this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.FaultTypeViewModel.prototype, {
        toJS: function () {
            return {
                Oid: this.Oid(),
                Fault: this.Fault(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function (data) {
            if (data) {
                this.Oid(data.Oid);
                this.Fault(data.Fault);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function () {
            this.Oid(undefined);
            this.Fault(undefined);
            this.GCRecord(undefined);
        }
    });
})();