(function() {
    IntelliServe_Dxtreme.GroupViewModel = function(data) {
            this.Oid = ko.observable();
            this.GroupName = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.GroupViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                GroupName: this.GroupName(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.GroupName(data.GroupName);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.GroupName(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
        }
    });
})();