(function() {
    IntelliServe_Dxtreme.JobCardChecklistItemViewModel = function(data) {
            this.Oid = ko.observable();
            this.JobCardChecklist1 = ko.observable();
            this.Order = ko.observable();
            this.Label = ko.observable();
            this.Units = ko.observable();
            this.DataType = ko.observable();
            this.Value = ko.observable();
            this.CheckListGroup1 = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobCardChecklistItemViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Value: this.Value() == 'true' ? 'Yes' : this.Value() == 'false' ? 'No' : this.Value(),
            };
        },

        toJSNew: function () {
            return {
                Oid: this.Oid(),
                JobCardChecklist1: this.JobCardChecklist1(),
                Order: this.Order(),
                Label: this.Label(),
                Units: this.Units(),
                DataType: this.DataType(),
                CheckListGroup1: this.CheckListGroup1(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.JobCardChecklist1)
                    this.JobCardChecklist1(new IntelliServe_Dxtreme.JobCardChecklistViewModel(data.JobCardChecklist1));
                this.Order(data.Order);
                this.Label(data.Label);
                this.Units(data.Units);
                this.DataType(data.DataType);
                this.Value(data.Value);
                if(data.CheckListGroup1)
                    this.CheckListGroup1(new IntelliServe_Dxtreme.CheckListGroupViewModel(data.CheckListGroup1));
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.JobCardChecklist1(undefined);
            this.Order(undefined);
            this.Label(undefined);
            this.Units(undefined);
            this.DataType(undefined);
            this.Value(undefined);
            this.CheckListGroup1(undefined);
            this.GCRecord(undefined);
        }
    });
})();