(function() {
    IntelliServe_Dxtreme.JobCardItemViewModel = function(data) {
            this.Oid = ko.observable();
            this.JobCard1 = ko.observable();
            this.Item1 = ko.observable();
            this.Description = ko.observable();
            this.CostPrice = ko.observable();
            this.SellingPrice = ko.observable();
            this.Quantity = ko.observable();
            this.DateTime = ko.observable();
            this.VAT = ko.observable();
            this.VatPercentage = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobCardItemViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                JobCard1: this.JobCard1(),
                Item1: this.Item1(),
                Description: this.Description(),
                CostPrice: this.CostPrice(),
                SellingPrice: this.SellingPrice(),
                Quantity: this.Quantity(),
                VAT: this.VAT(),
                VatPercentage: this.VatPercentage(),
                GCRecord: this.GCRecord(),
                DateTime: this.DateTime(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
                if(data.Item1)
                    this.Item1(new IntelliServe_Dxtreme.ItemViewModel(data.Item1));
                this.Description(data.Description);
                this.CostPrice(data.CostPrice);
                this.SellingPrice(data.SellingPrice);
                this.Quantity(data.Quantity);
                this.DateTime(data.DateTime);
                this.VAT(data.VAT);
                this.VatPercentage(data.VatPercentage);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.JobCard1(undefined);
            this.Item1(undefined);
            this.Description(undefined);
            this.CostPrice(undefined);
            this.SellingPrice(undefined);
            this.Quantity(undefined);
            this.DateTime(undefined);
            this.VAT(undefined);
            this.VatPercentage(undefined);
        }
    });
})();