(function() {
    IntelliServe_Dxtreme.JobCardSignatureViewModel = function(data) {
            this.Oid = ko.observable();
            this.Image = ko.observable();
            this.Latitude = ko.observable();
            this.Longitude = ko.observable();
            this.JobCard1 = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobCardSignatureViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Image: this.Image(),
                Latitude: this.Latitude(),
                Longitude: this.Longitude(),
                JobCard1: this.JobCard1(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Image(data.Image);
                this.Latitude(data.Latitude);
                this.Longitude(data.Longitude);
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Image(undefined);
            this.Latitude(undefined);
            this.ImaLongitudege(undefined);
            this.JobCard1(undefined);
        }
    });
})();