(function() {
    IntelliServe_Dxtreme.MobileBaseViewModel = function(data) {
            this.Oid = ko.observable();
            this.DateReceived = ko.observable();
            this.DateProcessed = ko.observable();
            this.SyncProcessed = ko.observable();
            this.SyncCompleted = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.MobileBaseViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                DateReceived: this.DateReceived(),
                DateProcessed: this.DateProcessed(),
                SyncProcessed: this.SyncProcessed(),
                SyncCompleted: this.SyncCompleted(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.DateReceived(data.DateReceived);
                this.DateProcessed(data.DateProcessed);
                this.SyncProcessed(data.SyncProcessed);
                this.SyncCompleted(data.SyncCompleted);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.DateReceived(undefined);
            this.DateProcessed(undefined);
            this.SyncProcessed(undefined);
            this.SyncCompleted(undefined);
        }
    });
})();