(function() {
    IntelliServe_Dxtreme.MobileJobCardItemViewModel = function (data) {
            this.Oid = ko.observable();
            this.MobileJobCard = ko.observable();
            this.Item1 = ko.observable();
            this.Quantity = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.MobileJobCardItemViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                MobileJobCard: this.MobileJobCard(),
                Item1: this.Item1(),
                Quantity: this.Quantity(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if (data.MobileJobCard)
                    this.MobileJobCard(new IntelliServe_Dxtreme.MobileJobCardViewModel(data.MobileJobCard));
                if (data.Item1)
                    this.Item1(new IntelliServe_Dxtreme.ItemViewModel(data.Item1));
                this.Quantity(data.DateOfIssue);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.MobileJobCard(undefined);
            this.Item1(undefined);
            this.Quantity(undefined);
        }
    });
})();