(function() {
    IntelliServe_Dxtreme.PersonViewModel = function(data) {
            this.Party = ko.observable();
            this.Oid = ko.observable();
            this.FirstName = ko.observable();
            this.LastName = ko.observable();
            this.MiddleName = ko.observable();
            this.Birthday = ko.observable();
            this.Email = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.PersonViewModel.prototype, {
        toJS: function() {
            return {
                Party: IntelliServe_Dxtreme.db.objectLink("Parties", this.Party() ? this.Party().Oid(): undefined),
                Oid: this.Oid(),
                FirstName: this.FirstName(),
                LastName: this.LastName(),
                MiddleName: this.MiddleName(),
                Birthday: this.Birthday(),
                Email: this.Email(),
            };
        },

        fromJS: function(data) {
            if(data) {
                if(data.Party)
                    this.Party(new IntelliServe_Dxtreme.PartyViewModel(data.Party));
                this.Oid(data.Oid);
                this.FirstName(data.FirstName);
                this.LastName(data.LastName);
                this.MiddleName(data.MiddleName);
                this.Birthday(data.Birthday);
                this.Email(data.Email);
            }
        },

        clear: function() {
            this.Party(undefined);
            this.Oid(undefined);
            this.FirstName(undefined);
            this.LastName(undefined);
            this.MiddleName(undefined);
            this.Birthday(undefined);
            this.Email(undefined);
        }
    });
})();