(function() {
    IntelliServe_Dxtreme.QuoteTermViewModel = function(data) {
            this.Oid = ko.observable();
            this.Name = ko.observable();
            this.TermsText = ko.observable();
            this.Default = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.QuoteTermViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Name: this.Name(),
                TermsText: this.TermsText(),
                Default: this.Default(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Name(data.Name);
                this.TermsText(data.TermsText);
                this.Default(data.Default);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Name(undefined);
            this.TermsText(undefined);
            this.Default(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
        }
    });
})();