(function() {
    IntelliServe_Dxtreme.ReportDataV2ViewModel = function(data) {
            this.Oid = ko.observable();
            this.ObjectTypeName = ko.observable();
            this.Content = ko.observable();
            this.Name = ko.observable();
            this.ParametersObjectTypeName = ko.observable();
            this.IsInplaceReport = ko.observable();
            this.PredefinedReportType = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.ReportDataV2ViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                ObjectTypeName: this.ObjectTypeName(),
                Content: this.Content(),
                Name: this.Name(),
                ParametersObjectTypeName: this.ParametersObjectTypeName(),
                IsInplaceReport: this.IsInplaceReport(),
                PredefinedReportType: this.PredefinedReportType(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.ObjectTypeName(data.ObjectTypeName);
                this.Content(data.Content);
                this.Name(data.Name);
                this.ParametersObjectTypeName(data.ParametersObjectTypeName);
                this.IsInplaceReport(data.IsInplaceReport);
                this.PredefinedReportType(data.PredefinedReportType);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.ObjectTypeName(undefined);
            this.Content(undefined);
            this.Name(undefined);
            this.ParametersObjectTypeName(undefined);
            this.IsInplaceReport(undefined);
            this.PredefinedReportType(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
        }
    });
})();