(function() {
    IntelliServe_Dxtreme.TeamLocationHistoryViewModel = function(data) {
            this.Oid = ko.observable();
            this.TeamLocationType = ko.observable();
            this.JobCard1 = ko.observable();
            this.LoggedInEmailAddress = ko.observable();
            this.Team1 = ko.observable();
            this.Longitude = ko.observable();
            this.Latitude = ko.observable();
            this.DateTime = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.TeamLocationHistoryViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                TeamLocationType: this.TeamLocationType(),
                JobCard1: IntelliServe_Dxtreme.db.objectLink("JobCards", this.JobCard1() ? this.JobCard1().Oid(): undefined),
                LoggedInEmailAddress: this.LoggedInEmailAddress(),
                Team1: IntelliServe_Dxtreme.db.objectLink("Teams", this.Team1() ? this.Team1().Oid(): undefined),
                Longitude: this.Longitude(),
                Latitude: this.Latitude(),
                DateTime: this.DateTime(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.TeamLocationType(data.TeamLocationType);
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
                this.LoggedInEmailAddress(data.LoggedInEmailAddress);
                if(data.Team1)
                    this.Team1(new IntelliServe_Dxtreme.TeamViewModel(data.Team1));
                this.Longitude(data.Longitude);
                this.Latitude(data.Latitude);
                this.DateTime(data.DateTime);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.TeamLocationType(undefined);
            this.JobCard1(undefined);
            this.LoggedInEmailAddress(undefined);
            this.Team1(undefined);
            this.Longitude(undefined);
            this.Latitude(undefined);
            this.DateTime(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
        }
    });
})();