(function() {
    IntelliServe_Dxtreme.UserBaseMultiTenantViewModel = function(data) {
            this.Oid = ko.observable();
            this.IsBackendCreation = ko.observable();
            this.IsMultiTenantCreated = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.UserBaseMultiTenantViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                IsBackendCreation: this.IsBackendCreation(),
                IsMultiTenantCreated: this.IsMultiTenantCreated(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.IsBackendCreation(data.IsBackendCreation);
                this.IsMultiTenantCreated(data.IsMultiTenantCreated);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.IsBackendCreation(undefined);
            this.IsMultiTenantCreated(undefined);
        }
    });
})();