(function() {
    IntelliServe_Dxtreme.UserBasViewModel = function(data) {
            this.EmployeeBase = ko.observable();
            this.Oid = ko.observable();
            this.Signature = ko.observable();
            this.UserName = ko.observable();
            this.IsActive = ko.observable();
            this.ChangePasswordOnFirstLogon = ko.observable();
            this.StoredPassword = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.UserBasViewModel.prototype, {
        toJS: function() {
            return {
                EmployeeBase: IntelliServe_Dxtreme.db.objectLink("EmployeeBases", this.EmployeeBase() ? this.EmployeeBase().Oid(): undefined),
                Oid: this.Oid(),
                Signature: this.Signature(),
                UserName: this.UserName(),
                IsActive: this.IsActive(),
                ChangePasswordOnFirstLogon: this.ChangePasswordOnFirstLogon(),
                StoredPassword: this.StoredPassword(),
            };
        },

        fromJS: function(data) {
            if(data) {
                if(data.EmployeeBase)
                    this.EmployeeBase(new IntelliServe_Dxtreme.EmployeeBasViewModel(data.EmployeeBase));
                this.Oid(data.Oid);
                this.Signature(data.Signature);
                this.UserName(data.UserName);
                this.IsActive(data.IsActive);
                this.ChangePasswordOnFirstLogon(data.ChangePasswordOnFirstLogon);
                this.StoredPassword(data.StoredPassword);
            }
        },

        clear: function() {
            this.EmployeeBase(undefined);
            this.Oid(undefined);
            this.Signature(undefined);
            this.UserName(undefined);
            this.IsActive(undefined);
            this.ChangePasswordOnFirstLogon(undefined);
            this.StoredPassword(undefined);
        }
    });
})();