(function() {
    IntelliServe_Dxtreme.v_Locations_MobileViewModel = function (data) {
            this.Oid = ko.observable();
            this.Client = ko.observable();
            this.FullAddress = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.v_Locations_MobileViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Client: this.Client(),
                FullAddress: this.FullAddress(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Client(data.Client);
                this.FullAddress(data.FullAddress);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Client(undefined);
            this.FullAddress(undefined);
            this.GCRecord(undefined);
        }
    });
})();