﻿IntelliServe_Dxtreme.ClientDetails = function (params) {
    "use strict";

    var id = params.id,
        client = new IntelliServe_Dxtreme.v_Clients_MobileViewModel(),
        dataSource,
        isReady = $.Deferred();

    function load() {
        return IntelliServe_Dxtreme.db.v_Clients_Mobile.byKey(id).done(function (data) {
            client.fromJS(data);
        });
    }

    function handleViewShowing() {
        client.clear();
        load().done(function () {
            isReady.resolve();
        });
    }

    dataSource = IntelliServe_Dxtreme.dbDataLayer.Instance().GetClientContacts(id);

    var viewModel = {
        id: id,
        viewShowing: handleViewShowing,
        client: client,
        dataSource: dataSource,
        isReady: isReady.promise()
    };

    return viewModel;
};