﻿IntelliServe_Dxtreme.Database = function (params) {
    "use strict";

    var dataSource = ko.observableArray([]);

    var pGetDatabasesCallback = function (data) {
        dataSource(JSON.parse(data));
    };

    function handleViewShowing() {
        IntelliServe_Dxtreme.dbDataLayer.Instance().GetDatabases(pGetDatabasesCallback);
    }

    function changeDatabase(data) {
        IntelliServe_Dxtreme.currentUser.Database(data.itemData.Database);
        IntelliServe_Dxtreme.app.navigate("Stats", { target: "current", clearHistory: true });
    }

    return {
        viewShowing: handleViewShowing,
        dataSource: dataSource,
        changeDatabase: changeDatabase
    };
};