(function() {
    IntelliServe_Dxtreme.AddressBasViewModel = function(data) {
            this.Oid = ko.observable();
            this.Latitude = ko.observable();
            this.Longitude = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.AddressBasViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Latitude: this.Latitude(),
                Longitude: this.Longitude(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Latitude(data.Latitude);
                this.Longitude(data.Longitude);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Latitude(undefined);
            this.Longitude(undefined);
        }
    });
})();