(function() {
    IntelliServe_Dxtreme.CheckListGroupViewModel = function(data) {
            this.Oid = ko.observable();
            this.GroupName = ko.observable();
            this.Order = ko.observable();
            this.Image = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.CheckListGroupViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                GroupName: this.GroupName(),
                Order: this.Order(),
                Image: this.Image(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.GroupName(data.GroupName);
                this.Order(data.Order);
                this.Image(data.Image);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.GroupName(undefined);
            this.Order(undefined);
            this.Image(undefined);
            this.GCRecord(undefined);
        }
    });
})();