(function() {
    IntelliServe_Dxtreme.ChecklistViewModel = function(data) {
            this.Oid = ko.observable();
            this.Description = ko.observable();
            this.ReportDataV2 = ko.observable();
            this.Notes = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.ChecklistViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Description: this.Description(),
                ReportDataV2: IntelliServe_Dxtreme.db.objectLink("ReportDataV2", this.ReportDataV2() ? this.ReportDataV2().Oid(): undefined),
                Notes: this.Notes(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Description(data.Description);
                if(data.ReportDataV2)
                    this.ReportDataV2(new IntelliServe_Dxtreme.ReportDataV2ViewModel(data.ReportDataV2));
                this.Notes(data.Notes);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Description(undefined);
            this.ReportDataV2(undefined);
            this.Notes(undefined);
            this.GCRecord(undefined);
        }
    });
})();