(function() {
    IntelliServe_Dxtreme.ClientBasViewModel = function(data) {
            this.Oid = ko.observable();
            this.FirstName = ko.observable();
            this.LastName = ko.observable();
            this.Company = ko.observable();
            this.Phone = ko.observable();
            this.Cell = ko.observable();
            this.AltPhone = ko.observable();
            this.Email = ko.observable();
            this.IDNumber = ko.observable();
            this.PostalAddress = ko.observable();
            this.VATNo = ko.observable();
            this.FullName = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.ClientBasViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                FirstName: this.FirstName(),
                LastName: this.LastName(),
                Company: this.Company(),
                Phone: this.Phone(),
                Cell: this.Cell(),
                AltPhone: this.AltPhone(),
                Email: this.Email(),
                IDNumber: this.IDNumber(),
                PostalAddress: this.PostalAddress(),
                VATNo: this.VATNo(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.FirstName(data.FirstName);
                this.LastName(data.LastName);
                this.Company(data.Company);
                this.Phone(data.Phone);
                this.Cell(data.Cell);
                this.AltPhone(data.AltPhone);
                this.Email(data.Email);
                this.IDNumber(data.IDNumber);
                this.PostalAddress(data.PostalAddress);
                this.VATNo(data.VATNo);
                this.GCRecord(data.GCRecord);
                this.FullName(data.Company == null ? data.FirstName + ' ' + data.LastName : data.Company);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.FirstName(undefined);
            this.LastName(undefined);
            this.Company(undefined);
            this.Phone(undefined);
            this.Cell(undefined);
            this.AltPhone(undefined);
            this.Email(undefined);
            this.IDNumber(undefined);
            this.PostalAddress(undefined);
            this.VATNo(undefined);
            this.GCRecord(undefined);
        }
    });
})();