(function() {
    IntelliServe_Dxtreme.EmployeeBasViewModel = function(data) {
            this.Person = ko.observable();
            this.Oid = ko.observable();
            this.Color = ko.observable();
            this.EmployeeType = ko.observable();
            this.Country1 = ko.observable();
            this.EmployeeNo = ko.observable();
            this.IDNo = ko.observable();
            this.PassportNo = ko.observable();
            this.PermitNo = ko.observable();
            this.PermitExpiry = ko.observable();
            this.CellNo = ko.observable();
            this.Notes = ko.observable();
            this.PassportCopy = ko.observable();
            this.IDCopy = ko.observable();
            this.PermitRequired = ko.observable();
            this.GoogleUserName = ko.observable();
            this.GooglePassword = ko.observable();
            this.Resource1 = ko.observable();
            this.Resigned = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.EmployeeBasViewModel.prototype, {
        toJS: function() {
            return {
                Person: IntelliServe_Dxtreme.db.objectLink("People", this.Person() ? this.Person().Oid(): undefined),
                Oid: this.Oid(),
                Color: this.Color(),
                EmployeeType: this.EmployeeType(),
                Country1: IntelliServe_Dxtreme.db.objectLink("Countries", this.Country1() ? this.Country1().Oid(): undefined),
                EmployeeNo: this.EmployeeNo(),
                IDNo: this.IDNo(),
                PassportNo: this.PassportNo(),
                PermitNo: this.PermitNo(),
                PermitExpiry: this.PermitExpiry(),
                CellNo: this.CellNo(),
                Notes: this.Notes(),
                PassportCopy: this.PassportCopy(),
                IDCopy: this.IDCopy(),
                PermitRequired: this.PermitRequired(),
                GoogleUserName: this.GoogleUserName(),
                GooglePassword: this.GooglePassword(),
                Resource1: IntelliServe_Dxtreme.db.objectLink("Resources", this.Resource1() ? this.Resource1().Oid(): undefined),
                Resigned: this.Resigned(),
            };
        },

        fromJS: function(data) {
            if(data) {
                if(data.Person)
                    this.Person(new IntelliServe_Dxtreme.PersonViewModel(data.Person));
                this.Oid(data.Oid);
                this.Color(data.Color);
                this.EmployeeType(data.EmployeeType);
                if(data.Country1)
                    this.Country1(new IntelliServe_Dxtreme.CountryViewModel(data.Country1));
                this.EmployeeNo(data.EmployeeNo);
                this.IDNo(data.IDNo);
                this.PassportNo(data.PassportNo);
                this.PermitNo(data.PermitNo);
                this.PermitExpiry(data.PermitExpiry);
                this.CellNo(data.CellNo);
                this.Notes(data.Notes);
                this.PassportCopy(data.PassportCopy);
                this.IDCopy(data.IDCopy);
                this.PermitRequired(data.PermitRequired);
                this.GoogleUserName(data.GoogleUserName);
                this.GooglePassword(data.GooglePassword);
                if(data.Resource1)
                    this.Resource1(new IntelliServe_Dxtreme.ResourceViewModel(data.Resource1));
                this.Resigned(data.Resigned);
            }
        },

        clear: function() {
            this.Person(undefined);
            this.Oid(undefined);
            this.Color(undefined);
            this.EmployeeType(undefined);
            this.Country1(undefined);
            this.EmployeeNo(undefined);
            this.IDNo(undefined);
            this.PassportNo(undefined);
            this.PermitNo(undefined);
            this.PermitExpiry(undefined);
            this.CellNo(undefined);
            this.Notes(undefined);
            this.PassportCopy(undefined);
            this.IDCopy(undefined);
            this.PermitRequired(undefined);
            this.GoogleUserName(undefined);
            this.GooglePassword(undefined);
            this.Resource1(undefined);
            this.Resigned(undefined);
        }
    });
})();