(function() {
    IntelliServe_Dxtreme.InvoiceViewModel = function(data) {
            this.Oid = ko.observable();
            this.InvoiceNumber = ko.observable();
            this.User1 = ko.observable();
            this.Client1 = ko.observable();
            this.Team1 = ko.observable();
            this.Location1 = ko.observable();
            this.Quote1 = ko.observable();
            this.JobCard1 = ko.observable();
            this.Ticket1 = ko.observable();
            this.DateOfIssue = ko.observable();
            this.PONumber = ko.observable();
            this.ReferenceNumber = ko.observable();
            this.DiscountPercent = ko.observable();
            this.Terms = ko.observable();
            this.Notes = ko.observable();
            this.VatPercentage = ko.observable();
            this.Excess = ko.observable();
            this.Transaction1 = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.DepositPercent = ko.observable();
            this.VATExempt = ko.observable();
            this.AdditionalPercentage = ko.observable();
            this.JobProject1 = ko.observable();
            this.FromRecurring = ko.observable();
            this.GCRecord = ko.observable();
            this.Consignment1 = ko.observable();
            this.InvoiceTotal = ko.observable();
            this.PaymentTotal = ko.observable();
            this.CreditTotal = ko.observable();
            this.Paid = ko.observable();
            this.AdditionalPercent = ko.observable();
            this.Currency = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.InvoiceViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                InvoiceNumber: this.InvoiceNumber(),
                User1: IntelliServe_Dxtreme.db.objectLink("Users", this.User1() ? this.User1().Oid(): undefined),
                Client1: IntelliServe_Dxtreme.db.objectLink("Clients", this.Client1() ? this.Client1().Oid(): undefined),
                Team1: IntelliServe_Dxtreme.db.objectLink("Teams", this.Team1() ? this.Team1().Oid(): undefined),
                Location1: IntelliServe_Dxtreme.db.objectLink("Locations", this.Location1() ? this.Location1().Oid(): undefined),
                Quote1: IntelliServe_Dxtreme.db.objectLink("Quotes", this.Quote1() ? this.Quote1().Oid(): undefined),
                JobCard1: IntelliServe_Dxtreme.db.objectLink("JobCards", this.JobCard1() ? this.JobCard1().Oid(): undefined),
                Ticket1: IntelliServe_Dxtreme.db.objectLink("Tickets", this.Ticket1() ? this.Ticket1().Oid(): undefined),
                DateOfIssue: this.DateOfIssue(),
                PONumber: this.PONumber(),
                ReferenceNumber: this.ReferenceNumber(),
                DiscountPercent: this.DiscountPercent(),
                Terms: this.Terms(),
                Notes: this.Notes(),
                VatPercentage: this.VatPercentage(),
                Excess: this.Excess(),
                Transaction1: IntelliServe_Dxtreme.db.objectLink("Transactions", this.Transaction1() ? this.Transaction1().Oid(): undefined),
                OptimisticLockField: this.OptimisticLockField(),
                DepositPercent: this.DepositPercent(),
                VATExempt: this.VATExempt(),
                AdditionalPercentage: this.AdditionalPercentage(),
                JobProject1: IntelliServe_Dxtreme.db.objectLink("JobProjects", this.JobProject1() ? this.JobProject1().Oid(): undefined),
                FromRecurring: this.FromRecurring(),
                GCRecord: this.GCRecord(),
                Consignment1: IntelliServe_Dxtreme.db.objectLink("Consignments", this.Consignment1() ? this.Consignment1().Oid(): undefined),
                InvoiceTotal: this.InvoiceTotal(),
                PaymentTotal: this.PaymentTotal(),
                CreditTotal: this.CreditTotal(),
                Paid: this.Paid(),
                AdditionalPercent: this.AdditionalPercent(),
                Currency: this.Currency(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.InvoiceNumber(data.InvoiceNumber);
                if(data.User1)
                    this.User1(new IntelliServe_Dxtreme.UserViewModel(data.User1));
                if(data.Client1)
                    this.Client1(new IntelliServe_Dxtreme.ClientViewModel(data.Client1));
                if(data.Team1)
                    this.Team1(new IntelliServe_Dxtreme.TeamViewModel(data.Team1));
                if(data.Location1)
                    this.Location1(new IntelliServe_Dxtreme.LocationViewModel(data.Location1));
                if(data.Quote1)
                    this.Quote1(new IntelliServe_Dxtreme.QuoteViewModel(data.Quote1));
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
                if(data.Ticket1)
                    this.Ticket1(new IntelliServe_Dxtreme.TicketViewModel(data.Ticket1));
                this.DateOfIssue(data.DateOfIssue);
                this.PONumber(data.PONumber);
                this.ReferenceNumber(data.ReferenceNumber);
                this.DiscountPercent(data.DiscountPercent);
                this.Terms(data.Terms);
                this.Notes(data.Notes);
                this.VatPercentage(data.VatPercentage);
                this.Excess(data.Excess);
                if(data.Transaction1)
                    this.Transaction1(new IntelliServe_Dxtreme.TransactionViewModel(data.Transaction1));
                this.OptimisticLockField(data.OptimisticLockField);
                this.DepositPercent(data.DepositPercent);
                this.VATExempt(data.VATExempt);
                this.AdditionalPercentage(data.AdditionalPercentage);
                if(data.JobProject1)
                    this.JobProject1(new IntelliServe_Dxtreme.JobProjectViewModel(data.JobProject1));
                this.FromRecurring(data.FromRecurring);
                this.GCRecord(data.GCRecord);
                if(data.Consignment1)
                    this.Consignment1(new IntelliServe_Dxtreme.ConsignmentViewModel(data.Consignment1));
                this.InvoiceTotal(data.InvoiceTotal);
                this.PaymentTotal(data.PaymentTotal);
                this.CreditTotal(data.CreditTotal);
                this.Paid(data.Paid);
                this.AdditionalPercent(data.AdditionalPercent);
                this.Currency(data.Currency);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.InvoiceNumber(undefined);
            this.User1(undefined);
            this.Client1(undefined);
            this.Team1(undefined);
            this.Location1(undefined);
            this.Quote1(undefined);
            this.JobCard1(undefined);
            this.Ticket1(undefined);
            this.DateOfIssue(undefined);
            this.PONumber(undefined);
            this.ReferenceNumber(undefined);
            this.DiscountPercent(undefined);
            this.Terms(undefined);
            this.Notes(undefined);
            this.VatPercentage(undefined);
            this.Excess(undefined);
            this.Transaction1(undefined);
            this.OptimisticLockField(undefined);
            this.DepositPercent(undefined);
            this.VATExempt(undefined);
            this.AdditionalPercentage(undefined);
            this.JobProject1(undefined);
            this.FromRecurring(undefined);
            this.GCRecord(undefined);
            this.Consignment1(undefined);
            this.InvoiceTotal(undefined);
            this.PaymentTotal(undefined);
            this.CreditTotal(undefined);
            this.Paid(undefined);
            this.AdditionalPercent(undefined);
            this.Currency(undefined);
        }
    });
})();