(function() {
    IntelliServe_Dxtreme.JobCardChecklistViewModel = function(data) {
            this.Oid = ko.observable();
            this.JobCard1 = ko.observable();
            this.Checklist1 = ko.observable();
            this.Description = ko.observable();
            this.CustomStatu = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobCardChecklistViewModel.prototype, {
        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
                if(data.Checklist1)
                    this.Checklist1(new IntelliServe_Dxtreme.ChecklistViewModel(data.Checklist1));
                this.Description(data.Description);
                if (data.CustomStatu)
                    this.CustomStatu(new IntelliServe_Dxtreme.CustomStatuViewModel(data.CustomStatu));
                this.GCRecord(data.GCRecord);
            }
        },

        toJS: function () {
            return {
                Oid: this.Oid(),
                JobCard1: this.JobCard1(),
                Checklist1: this.Checklist1(),
                CustomStatu: this.CustomStatu(),
                Description: this.Description(),
            };
        },

        clear: function() {
            this.Oid(undefined);
            this.JobCard1(undefined);
            this.Checklist1(undefined);
            this.Description(undefined);
            this.CustomStatu(undefined);
            this.GCRecord(undefined);
        }
    });
})();