(function() {
    IntelliServe_Dxtreme.JobCardEquipmentViewModel = function (data) {
            this.Oid = ko.observable();
            this.JobCard1 = ko.observable();
            this.Equipment1 = ko.observable();
            this.FaultType1 = ko.observable();
            this.FaultDescription = ko.observable();
            this.Code = ko.observable();
            this.RepairsDone = ko.observable();
            this.DateBookedIn = ko.observable();
            this.DateReturned = ko.observable();
            this.Status = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobCardEquipmentViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                JobCard1: this.JobCard1(),
                Equipment1: this.Equipment1(),
                FaultType1: this.FaultType1(),
                FaultDescription: this.FaultDescription(),
                Code: this.Code(),
                RepairsDone: this.RepairsDone(),
                DateBookedIn: this.DateBookedIn(),
                DateReturned: this.DateReturned(),
                Status: this.Status(),
                GCRecord: this.GCRecord()
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
                if (data.Equipment1)
                    this.Equipment1(new IntelliServe_Dxtreme.EquipmentViewModel(data.Equipment1));
                if (data.FaultType1)
                    this.FaultType1(new IntelliServe_Dxtreme.FaultTypeViewModel(data.FaultType1));
                this.FaultDescription(data.FaultDescription);
                this.Code(data.Code);
                this.RepairsDone(data.RepairsDone);
                this.DateBookedIn(data.DateBookedIn);
                this.DateReturned(data.DateReturned);
                this.Status(data.Status);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function () {
            this.Oid(undefined);
            this.JobCard1(undefined);
            this.Equipment1(undefined);
            this.FaultType1(undefined);
            this.FaultDescription(undefined);
            this.Code(undefined);
            this.RepairsDone(undefined);
            this.DateBookedIn(undefined);
            this.DateReturned(undefined);
            this.Status(undefined);
            this.GCRecord(undefined);
        }
    });
})();