(function() {
    IntelliServe_Dxtreme.JobCardNoteViewModel = function(data) {
            this.Oid = ko.observable();
            this.Description = ko.observable();
            this.JobCard1 = ko.observable();
            this.DateTime = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobCardNoteViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Description: this.Description(),
                JobCard1: this.JobCard1(),
                DateTime: this.DateTime(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Description(data.Description);
                this.DateTime(data.DateTime);
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Description(undefined);
            this.JobCard1(undefined);
            this.DateTime(undefined);
        }
    });
})();