(function() {
    IntelliServe_Dxtreme.JobCardViewModel = function(data) {
        this.Oid = ko.observable();
        this.CustomStatu = ko.observable();
        this.StatusDescription = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobCardViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                CustomStatu: IntelliServe_Dxtreme.db.objectLink("CustomStatus", this.CustomStatu() ? this.CustomStatu().Oid() : undefined),
                StatusDescription: this.StatusDescription()
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.CustomStatu)
                    this.CustomStatu(new IntelliServe_Dxtreme.CustomStatuViewModel(data.CustomStatu));
                this.StatusDescription(data.StatusDescription);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.CustomStatu(undefined);
        }
    });
})();