﻿(function () {
    IntelliServe_Dxtreme.JobCardTimeLogViewModel = function (data) {
        this.Oid = ko.observable();
        this.JobCard1 = ko.observable();
        this.BookedTime = ko.observable();
        this.StartDate = ko.observable();
        this.StartODOReading = ko.observable();
        this.EndDate = ko.observable();
        this.EndODOReading = ko.observable();
        this.ActualKMTraveled = ko.observable();
        if (data)
            this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobCardTimeLogViewModel.prototype, {
        toJS: function () {
            return {
                Oid: this.Oid(),
                JobCard1: this.JobCard1(),
                BookedTime: this.BookedTime(),
                StartDate: this.StartDate(),
                StartODOReading: this.StartODOReading(),
                EndDate: this.EndDate(),
                EndODOReading: this.EndODOReading(),
                ActualKMTraveled: this.ActualKMTraveled(),
            };
        },

        fromJS: function (data) {
            if (data) {
                this.Oid(data.Oid);
                if (data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
                this.BookedTime(data.BookedTime);
                this.StartDate(data.StartDate);
                this.StartODOReading(data.StartODOReading);
                this.EndDate(data.EndDate);
                this.EndODOReading(data.EndODOReading);
                this.ActualKMTraveled(data.ActualKMTraveled);
            }
        },

        clear: function () {
            this.Oid(undefined);
            this.JobCard1(undefined);
            this.BookedTime(undefined);
            this.StartDate(undefined);
            this.StartODOReading(undefined);
            this.EndDate(undefined);
            this.EndODOReading(undefined);
            this.ActualKMTraveled(undefined);
        }
    });
})();