(function() {
    IntelliServe_Dxtreme.LocationViewModel = function(data) {
            this.Oid = ko.observable();
            this.ClientContact1 = ko.observable();
            this.AddressBase = ko.observable();
            this.Client1 = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.LocationViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                ClientContact1: this.ClientContact1(),
                AddressBase: this.AddressBase(),
                Client1: this.Client1(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.ClientContact1)
                    this.ClientContact1(new IntelliServe_Dxtreme.ClientContactViewModel(data.ClientContact1));
                if (data.AddressBase)
                    this.AddressBase(new IntelliServe_Dxtreme.AddressBaseViewModel(data.ClientContact1));
                if(data.Client1)
                    this.Client1(new IntelliServe_Dxtreme.ClientViewModel(data.Client1));
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.ClientContact1(undefined);
            this.AddressBase(undefined);
            this.Client1(undefined);
            this.GCRecord(undefined);
        }
    });
})();