(function() {
    IntelliServe_Dxtreme.MobileJobCardViewModel = function (data) {
        this.Oid = ko.observable();
        this.Client1 = ko.observable();
        this.Company = ko.observable();
        this.FirstName = ko.observable();
        this.LastName = ko.observable();
        this.Email = ko.observable();
        this.Location1 = ko.observable();
        this.LocationName = ko.observable();
        this.Street = ko.observable();
        this.Suburb = ko.observable();
        this.City = ko.observable();
        this.PostalCode = ko.observable();
        this.Province = ko.observable();
        this.JobType1 = ko.observable();
        this.BookedTime = ko.observable();
        this.BookedEndTime = ko.observable();
        this.ReferenceNumber = ko.observable();
        this.PolicyNumber = ko.observable();
        this.Notes = ko.observable();
        this.CreatedBy = ko.observable();
        if (data)
            this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.MobileJobCardViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Client1: this.Client1(),
                Company: this.Company(),
                FirstName: this.FirstName(),
                LastName: this.LastName(),
                Email: this.Email(),
                Location1: this.Location1(),
                LocationName: this.LocationName(),
                Street: this.Street(),
                Suburb: this.Suburb(),
                City: this.City(),
                PostalCode: this.PostalCode(),
                Province: this.Province(),
                JobType1: this.JobType1(),
                BookedTime: this.BookedTime(),
                BookedEndTime: this.BookedEndTime(),
                ReferenceNumber: this.ReferenceNumber(),
                PolicyNumber: this.PolicyNumber(),
                Notes: this.Notes(),
                CreatedBy: this.CreatedBy(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Client1(data.Client1);
                this.Company(data.Company);
                this.FirstName(data.FirstName);
                this.LastName(data.LastName);
                this.Email(data.Email);
                this.Location1(data.Location1);
                this.LocationName(data.LocationName);
                this.Street(data.Street);
                this.Suburb(data.Suburb);
                this.City(data.City);
                this.PostalCode(data.PostalCode);
                this.Province(data.Province);
                this.JobType1(data.JobType1);
                this.BookedTime(data.BookedTime);
                this.BookedEndTime(data.BookedEndTime);
                this.ReferenceNumber(data.ReferenceNumber);
                this.Notes(data.Notes);
                this.CreatedBy(data.CreatedBy);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Client1(undefined);
            this.Company(undefined);
            this.FirstName(undefined);
            this.LastName(undefined);
            this.Email(undefined);
            this.Location1(undefined);
            this.LocationName(undefined);
            this.Street(undefined);
            this.Suburb(undefined);
            this.City(undefined);
            this.PostalCode(undefined);
            this.Province(undefined);
            this.JobType1(undefined);
            this.BookedTime(undefined);
            this.BookedEndTime(undefined);
            this.ReferenceNumber(undefined);
            this.Notes(undefined);
            this.CreatedBy(undefined);
        }
    });
})();