(function() {
    IntelliServe_Dxtreme.QuoteViewModel = function(data) {
            this.Oid = ko.observable();
            this.QuoteNumber = ko.observable();
            this.User1 = ko.observable();
            this.Client1 = ko.observable();
            this.Location1 = ko.observable();
            this.Invoice1 = ko.observable();
            this.JobCard1 = ko.observable();
            this.Ticket1 = ko.observable();
            this.DateOfIssue = ko.observable();
            this.PONumber = ko.observable();
            this.DiscountPercent = ko.observable();
            this.Terms = ko.observable();
            this.Notes = ko.observable();
            this.VatPercentage = ko.observable();
            this.ConvertedToInvoice = ko.observable();
            this.ConvertedToJobCard = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.VATExempt = ko.observable();
            this.AdditionalPercentage = ko.observable();
            this.JobProject1 = ko.observable();
            this.GCRecord = ko.observable();
            this.QuoteTerm = ko.observable();
            this.AdditionalPercent = ko.observable();
            this.Currency = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.QuoteViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                QuoteNumber: this.QuoteNumber(),
                User1: IntelliServe_Dxtreme.db.objectLink("Users", this.User1() ? this.User1().Oid(): undefined),
                Client1: IntelliServe_Dxtreme.db.objectLink("Clients", this.Client1() ? this.Client1().Oid(): undefined),
                Location1: IntelliServe_Dxtreme.db.objectLink("Locations", this.Location1() ? this.Location1().Oid(): undefined),
                Invoice1: IntelliServe_Dxtreme.db.objectLink("Invoices", this.Invoice1() ? this.Invoice1().Oid(): undefined),
                JobCard1: IntelliServe_Dxtreme.db.objectLink("JobCards", this.JobCard1() ? this.JobCard1().Oid(): undefined),
                Ticket1: IntelliServe_Dxtreme.db.objectLink("Tickets", this.Ticket1() ? this.Ticket1().Oid(): undefined),
                DateOfIssue: this.DateOfIssue(),
                PONumber: this.PONumber(),
                DiscountPercent: this.DiscountPercent(),
                Terms: this.Terms(),
                Notes: this.Notes(),
                VatPercentage: this.VatPercentage(),
                ConvertedToInvoice: this.ConvertedToInvoice(),
                ConvertedToJobCard: this.ConvertedToJobCard(),
                OptimisticLockField: this.OptimisticLockField(),
                VATExempt: this.VATExempt(),
                AdditionalPercentage: this.AdditionalPercentage(),
                JobProject1: IntelliServe_Dxtreme.db.objectLink("JobProjects", this.JobProject1() ? this.JobProject1().Oid(): undefined),
                GCRecord: this.GCRecord(),
                QuoteTerm: IntelliServe_Dxtreme.db.objectLink("QuoteTerms", this.QuoteTerm() ? this.QuoteTerm().Oid(): undefined),
                AdditionalPercent: this.AdditionalPercent(),
                Currency: this.Currency(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.QuoteNumber(data.QuoteNumber);
                if(data.User1)
                    this.User1(new IntelliServe_Dxtreme.UserViewModel(data.User1));
                if(data.Client1)
                    this.Client1(new IntelliServe_Dxtreme.ClientViewModel(data.Client1));
                if(data.Location1)
                    this.Location1(new IntelliServe_Dxtreme.LocationViewModel(data.Location1));
                if(data.Invoice1)
                    this.Invoice1(new IntelliServe_Dxtreme.InvoiceViewModel(data.Invoice1));
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
                if(data.Ticket1)
                    this.Ticket1(new IntelliServe_Dxtreme.TicketViewModel(data.Ticket1));
                this.DateOfIssue(data.DateOfIssue);
                this.PONumber(data.PONumber);
                this.DiscountPercent(data.DiscountPercent);
                this.Terms(data.Terms);
                this.Notes(data.Notes);
                this.VatPercentage(data.VatPercentage);
                this.ConvertedToInvoice(data.ConvertedToInvoice);
                this.ConvertedToJobCard(data.ConvertedToJobCard);
                this.OptimisticLockField(data.OptimisticLockField);
                this.VATExempt(data.VATExempt);
                this.AdditionalPercentage(data.AdditionalPercentage);
                if(data.JobProject1)
                    this.JobProject1(new IntelliServe_Dxtreme.JobProjectViewModel(data.JobProject1));
                this.GCRecord(data.GCRecord);
                if(data.QuoteTerm)
                    this.QuoteTerm(new IntelliServe_Dxtreme.QuoteTermViewModel(data.QuoteTerm));
                this.AdditionalPercent(data.AdditionalPercent);
                this.Currency(data.Currency);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.QuoteNumber(undefined);
            this.User1(undefined);
            this.Client1(undefined);
            this.Location1(undefined);
            this.Invoice1(undefined);
            this.JobCard1(undefined);
            this.Ticket1(undefined);
            this.DateOfIssue(undefined);
            this.PONumber(undefined);
            this.DiscountPercent(undefined);
            this.Terms(undefined);
            this.Notes(undefined);
            this.VatPercentage(undefined);
            this.ConvertedToInvoice(undefined);
            this.ConvertedToJobCard(undefined);
            this.OptimisticLockField(undefined);
            this.VATExempt(undefined);
            this.AdditionalPercentage(undefined);
            this.JobProject1(undefined);
            this.GCRecord(undefined);
            this.QuoteTerm(undefined);
            this.AdditionalPercent(undefined);
            this.Currency(undefined);
        }
    });
})();