(function() {
    IntelliServe_Dxtreme.ResourceViewModel = function(data) {
            this.Oid = ko.observable();
            this.Color = ko.observable();
            this.Caption = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.ResourceViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Color: this.Color(),
                Caption: this.Caption(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Color(data.Color);
                this.Caption(data.Caption);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Color(undefined);
            this.Caption(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
        }
    });
})();