(function() {
    IntelliServe_Dxtreme.TeamLocationViewModel = function(data) {
            this.Oid = ko.observable();
            this.LoggedInEmailAddress = ko.observable();
            this.Longitude = ko.observable();
            this.Latitude = ko.observable();
            this.TeamLocationType = ko.observable();
            this.DateTime = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.TeamLocationViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                LoggedInEmailAddress: this.LoggedInEmailAddress(),
                Longitude: this.Longitude(),
                Latitude: this.Latitude(),
                TeamLocationType: this.TeamLocationType(),
                DateTime: this.DateTime(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.LoggedInEmailAddress(data.LoggedInEmailAddress);
                this.Longitude(data.Longitude);
                this.Latitude(data.Latitude);
                this.TeamLocationType(data.Latitude);
                this.DateTime(data.DateTime);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.LoggedInEmailAddress(undefined);
            this.Longitude(undefined);
            this.Latitude(undefined);
            this.TeamLocationType(undefined);
            this.DateTime(undefined);
        }
    });
})();