(function() {
    IntelliServe_Dxtreme.TeamTypeViewModel = function(data) {
            this.Oid = ko.observable();
            this.Description = ko.observable();
            this.OptimisticLockField = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.TeamTypeViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Description: this.Description(),
                OptimisticLockField: this.OptimisticLockField(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Description(data.Description);
                this.OptimisticLockField(data.OptimisticLockField);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Description(undefined);
            this.OptimisticLockField(undefined);
        }
    });
})();