﻿(function () {
    IntelliServe_Dxtreme.v_JobCardAttachment_MobileViewModel = function (data) {
        this.Oid = ko.observable();
        this.JobCard = ko.observable();
        this.Description = ko.observable();
        this.FileName = ko.observable();
        this.size = ko.observable();
        this.Content = ko.observable();
        this.GCRecord = ko.observable();
        if (data)
            this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.v_JobCardAttachment_MobileViewModel.prototype, {
        toJS: function () {
            return {
                Oid: this.Oid(),
                JobCard: this.JobCard(),
                Description: this.Description(),
                FileName: this.FileName(),
                size: this.size(),
                Content: this.Content(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function (data) {
            if (data) {
                this.Oid(data.Oid);
                this.JobCard(data.JobCard);
                this.Description(data.Description);
                this.FileName(data.FileName);
                this.size(data.size);
                this.Content(data.Content);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function () {
            this.Oid(undefined);
            this.JobCard(undefined);
            this.Description(undefined);
            this.FileName(undefined);
            this.size(undefined);
            this.Content(undefined);
            this.GCRecord(undefined);
        }
    });
})();