(function() {
    IntelliServe_Dxtreme.v_JobCardChecklistItems_MobileViewModel = function (data) {
            this.Oid = ko.observable();
            this.JobCard = ko.observable();
            this.JobCardChecklistOid = ko.observable();
            this.GroupName = ko.observable();
            this.Label = ko.observable();
            this.Order = ko.observable();
            this.Units = ko.observable();
            this.Value = ko.observable();
            this.CheckValue = ko.observable();
            this.DataType = ko.observable();
            this.NumberVisible = ko.observable();
            this.TextVisible = ko.observable();
            this.CheckVisible = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.v_JobCardChecklistItems_MobileViewModel.prototype, {
        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.JobCard(data.JobCard);
                this.JobCardChecklistOid(data.JobCardChecklistOid);
                this.GroupName(data.GroupName);
                this.Label(data.Label);
                this.Order(data.Order);
                this.Units(data.Units);
                this.Value(data.Value == 'Yes' ? true : data.Value == 'No' ? false : data.Value);
                this.DataType(data.DataType);
                this.NumberVisible(data.NumberVisible);
                this.TextVisible(data.TextVisible);
                this.CheckVisible(data.CheckVisible);
            }
        },
        clear: function () {
            this.Oid(undefined);
            this.JobCard(undefined);
            this.JobCardChecklistOid(undefined);
            this.GroupName(undefined);
            this.Label(undefined);
            this.Order(undefined);
            this.Units(undefined);
            this.Value(undefined);
            this.DataType(undefined);
            this.NumberVisible(undefined);
            this.TextVisible(undefined);
            this.CheckVisible(undefined);
        }
    });
})();