(function() {
    IntelliServe_Dxtreme.v_Clients_MobileViewModel = function (data) {
            this.Oid = ko.observable();
            this.FirstName = ko.observable();
            this.LastName = ko.observable();
            this.Company = ko.observable();
            this.FullName = ko.observable();
            this.GCRecord = ko.observable();
            this.Cell = ko.observable();
            this.Phone = ko.observable();
            this.Email = ko.observable();
            this.AltPhone = ko.observable();
            this.FullAddress = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.v_Clients_MobileViewModel.prototype, {
        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.FirstName(data.FirstName);
                this.LastName(data.LastName);
                this.Company(data.Company);
                this.FullName(data.FullName);
                this.GCRecord(data.GCRecord);
                this.Cell(data.Cell);
                this.Phone(data.Phone);
                this.Email(data.Email);
                this.AltPhone(data.AltPhone);
                this.FullAddress(data.FullAddress);
            }
        },
        clear: function () {
            this.Oid(undefined);
            this.FirstName(undefined);
            this.LastName(undefined);
            this.Company(undefined);
            this.FullName(undefined);
            this.GCRecord(undefined);
            this.Cell(undefined);
            this.Phone(undefined);
            this.Email(undefined);
            this.AltPhone(undefined);
            this.FullAddress(undefined);
        }
    });
})();