// NOTE object below must be a valid JSON
window.IntelliServe_Dxtreme = $.extend(true, window.IntelliServe_Dxtreme, {
  "config": {
    "endpoints": {
      "db": {
        "local": "https://intelliservedataservice.digg-it.co.za/DataService.svc",
        "production": "https://intelliservedataservice.digg-it.co.za/DataService.svc"
      }
    },
    "services": {
      "db": {
        "entities": {
          "JobCards": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "Teams": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "Items": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "TeamBases": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "ClientBases": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "v_Jobcards_Mobile": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "v_Clients_Mobile": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "v_JobCardChecklistItems_Mobile": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "v_Locations_Mobile": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobCardImages": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobCardSignatures": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "TeamLocations": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "CustomStatus": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobCardNotes": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobCardItems": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobCardEquipments": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "Quotes": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "QuoteItems": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobCardTimeLogs": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "MobileJobCards": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "MobileJobCardItems": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "MobileBases": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobTypes": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "Clients": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "Locations": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobCardChecklists": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "JobCardChecklistItems": {
            "key": "Oid",
            "keyType": "Guid"
          },
          "Checklists": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "ChecklistItems": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "CheckListGroups": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "ClientContacts": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "AddressBases": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "JobCardEquipments": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "FaultTypes": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "Equipments": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "EquipmentTypes": {
              "key": "Oid",
              "keyType": "Guid"
          },
          "v_JobCardAttachment_Mobile": {
              "key": "Oid",
              "keyType": "Guid"
          }
        }
      }
    }
  },
  "services.db.entities": {
    "JobCards": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "Teams": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "Items": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "TeamBases": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "ClientBases": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "v_Jobcards_Mobile": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "v_Clients_Mobile": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "v_Locations_Mobile": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobCardImages": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobCardSignatures": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "TeamLocations": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "CustomStatus": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobCardNotes": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobCardItems": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobCardEquipments": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "Quotes": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "QuoteItems": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobCardTimeLogs": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "MobileJobCards": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "MobileJobCardItems": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "MobileBases": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobTypes": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "Clients": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "Locations": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobCardChecklists": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "JobCardChecklistItems": {
      "key": "Oid",
      "keyType": "Guid"
    },
    "Checklists": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "ChecklistItems": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "CheckListGroups": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "ClientContacts": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "v_JobCardChecklistItems_Mobile": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "AddressBases": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "JobCardEquipments": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "FaultTypes": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "Equipments": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "EquipmentTypes": {
        "key": "Oid",
        "keyType": "Guid"
    },
    "v_JobCardAttachment_Mobile": {
        "key": "Oid",
        "keyType": "Guid"
    }
  }
});
