IntelliServe_Dxtreme.Settings = function (params) {
    "use strict";

    var settings = IntelliServe_Dxtreme.currentUser

    function handleSave() {
        IntelliServe_Dxtreme.currentUser.LocationServicesEnabled(settings.LocationServicesEnabled());
        IntelliServe_Dxtreme.currentUser.MapService(settings.MapService());

        if (settings.MapService()) {
            IntelliServe_Dxtreme.currentUser.MapServiceDescription("bing");
        } else {
            IntelliServe_Dxtreme.currentUser.MapServiceDescription("google");
        }

        DevExpress.ui.notify('Successfully saved', 'success', 3000);
    }

    return {
        settings: settings,
        handleSave: handleSave
    };
};